<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;

class IntervaloRepository {
    /** @var Connection */
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ) {
        $this->connection           = $entityManager->getConnection();
    }

    public function deleteIntervalo(
        array $params
    ): int {
        $sql = <<<SQL
            DELETE FROM
                GPE_MARCACAOPONTO
            WHERE
                NRORG = :P_NRORG AND
                NRVINCULOM = :P_NRVINCULO AND
                TO_CHAR(DTHRMARCACAOPONTO, 'DD/MM/YYYY') = :P_DATE AND
                TO_CHAR(DTHRMARCACAOPONTO, 'HH24:MI') = :P_TIME AND
                IDREFERINTERVALO = 'S'

SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $qntDeletedRows = $std->rowCount();

        return $qntDeletedRows;
    }
}