/*
 @C:\Web_575\Sql\End_Conv\Oracle\5091_Imposto_Integrao.SQL

 raise_application_error(-20501, '' , True);
*/

CREATE OR REPLACE PROCEDURE IMPOSTO_INTEGRACAO(
   P_FILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,
   P_LANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE)

IS
   V_TOTALNOTA NUMBER;
   V_VRPERC NUMBER;
   V_CDCTBLSAIDEN VARCHAR2(20);
   V_IDENCARGO VARCHAR2(01);
   V_CDIMPOSTRIB VARCHAR2(1000);
   V_IDORIGDESTNF VARCHAR2(01);
   V_IMPOCONTAB NUMBER;
   V_TAXABASECALC NUMBER;
   V_CONTABCALC NUMBER;
   V_ICMS VARCHAR2(01);
   V_VRREDUCAO NUMBER;
   V_IDOPERDEVONF VARCHAR2(01);
   V_SEQUIMPOSTNF NUMBER;
   V_CARGA NUMBER;
   V_CDTIPOOPER VARCHAR2(02);
   V_PERDBCALC NUMBER;
   V_LIQUIITEM NUMBER;
   V_TOTALPRODUTOS NUMBER;
BEGIN
   SELECT SUM(VRNOTAFISC), NVL(MAX(IDORIGDESTNF), 'C'), MAX(CDTIPOOPER), SUM(VRPRODUTOS)
     INTO V_TOTALNOTA, V_IDORIGDESTNF, V_CDTIPOOPER, V_TOTALPRODUTOS
     FROM NOTAFISCAL
    WHERE (CDFILIAL   = P_FILIAL)
      AND (NRLANCTONF = P_LANCTONF);

   SELECT NVL(MAX(IDOPERDEVONF),'N')
     INTO V_IDOPERDEVONF
     FROM TIPOOPERAC
    WHERE IDENTRSAIDOP = 'S'
      AND CDTIPOOPER   = V_CDTIPOOPER;

   FOR C_ITEM IN (SELECT CDPRODUTO, VRTOTAITEM, NRSEQITPROD,
                  VRFRETEITEM, VRSEGURITEM, VRENCARGODESC, VROUTRASDESPITEM
                    FROM ITEMPRODUTO
                   WHERE (CDFILIAL   = P_FILIAL)
                     AND (NRLANCTONF = P_LANCTONF)) LOOP
      IF (V_TOTALPRODUTOS = 0) OR (V_TOTALPRODUTOS IS NULL) THEN
         V_VRPERC  := (C_ITEM.VRTOTAITEM);
      ELSE
         V_VRPERC  := (C_ITEM.VRTOTAITEM/V_TOTALPRODUTOS);
      END IF;

      UPDATE ITEMPRODUTO
      SET VRBRUTITEM = ROUND((V_VRPERC  * V_TOTALNOTA),2)
      WHERE CDFILIAL    = P_FILIAL
        AND NRLANCTONF  = P_LANCTONF
        AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
      IF C_ITEM.VRFRETEITEM > 0 THEN
         SELECT MAX(E.CDCTBLSAIDEN), MAX(E.IDENCARGO)
           INTO V_CDCTBLSAIDEN, V_IDENCARGO
           FROM ENCARGO E, ENCARGONFE N
          WHERE N.CDENCARGONFE = '01'
            AND E.CDENCARGONFE = N.CDENCARGONFE;

         IF V_CDCTBLSAIDEN IS NULL THEN
            IF V_IDENCARGO = 'A' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM + NVL(C_ITEM.VRFRETEITEM,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
            IF V_IDENCARGO = 'D' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM - NVL(C_ITEM.VRFRETEITEM,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
         END IF;
      END IF;
      IF C_ITEM.VRSEGURITEM > 0 THEN
         SELECT MAX(E.CDCTBLSAIDEN), MAX(E.IDENCARGO)
           INTO V_CDCTBLSAIDEN, V_IDENCARGO
           FROM ENCARGO E, ENCARGONFE N
          WHERE N.CDENCARGONFE = '02'
            AND E.CDENCARGONFE = N.CDENCARGONFE;

         IF V_CDCTBLSAIDEN IS NULL THEN
            IF V_IDENCARGO = 'A' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM + NVL(C_ITEM.VRSEGURITEM,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
            IF V_IDENCARGO = 'D' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM - NVL(C_ITEM.VRSEGURITEM,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
         END IF;
      END IF;
      IF C_ITEM.VRENCARGODESC > 0 THEN
         SELECT MAX(E.CDCTBLSAIDEN), MAX(E.IDENCARGO)
           INTO V_CDCTBLSAIDEN, V_IDENCARGO
           FROM ENCARGO E, ENCARGONFE N
          WHERE N.CDENCARGONFE = '03'
            AND E.CDENCARGONFE = N.CDENCARGONFE;

         IF V_CDCTBLSAIDEN IS NULL THEN
            IF V_IDENCARGO = 'A' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM + NVL(C_ITEM.VRENCARGODESC,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
            IF V_IDENCARGO = 'D' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM - NVL(C_ITEM.VRENCARGODESC,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
         END IF;
      END IF;
      IF C_ITEM.VROUTRASDESPITEM > 0 THEN
         SELECT MAX(E.CDCTBLSAIDEN), MAX(E.IDENCARGO)
           INTO V_CDCTBLSAIDEN, V_IDENCARGO
           FROM ENCARGO E, ENCARGONFE N
          WHERE N.CDENCARGONFE = '04'
            AND E.CDENCARGONFE = N.CDENCARGONFE;

         IF V_CDCTBLSAIDEN IS NULL THEN
            IF V_IDENCARGO = 'A' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM + NVL(C_ITEM.VROUTRASDESPITEM,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
            IF V_IDENCARGO = 'D' THEN
               UPDATE ITEMPRODUTO
               SET VRCONTITEM = ROUND((VRCONTITEM - NVL(C_ITEM.VROUTRASDESPITEM,0)),2)
               WHERE CDFILIAL    = P_FILIAL
                 AND NRLANCTONF  = P_LANCTONF
                 AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
            END IF;
         END IF;
      END IF;
   END LOOP;
   FOR C_IMP IN (SELECT II.CDIMPOSTO, II.VRIMPOSTOIT, II.CDFISCALIT, II.NRSEQITPROD, II.VRPERREDBCIT,
                        II.CDSITUTRIBIT, II.CDFISCOPERIT, II.CDSITUTRIBITNFE, II.IDMODBCITNFE IDMODBCNFE, II.IDMODBCSTITNFE IDMODBCSTNFE,
                        II.CDNATUBCALPCIT CDNATUBCPCSTNFE, II.CDTPCREDPICOITE CDTPCRPICOSTNFE, II.VRPERMAJBCIT, II.VRPARDEDIT,
                        I.IDTRATIMPO, I.IDIMPORECUP, I.CDCCTBLPASS, I.CDCCTBLATIV, I.IDTIPCONTAB
                   FROM ITEMPROIMPOS II, IMPOSTO I
                  WHERE (II.CDFILIAL   = P_FILIAL)
                    AND (II.NRLANCTONF = P_LANCTONF)
                    AND (I.CDIMPOSTO = II.CDIMPOSTO)) LOOP
      V_CDIMPOSTRIB  := null;
      FOR C_ICMSST IN (SELECT CDIMPOSTO
                         FROM IMPOSTO
                        WHERE CDIMPOSTRIB = C_IMP.CDIMPOSTO)
      LOOP
          V_CDIMPOSTRIB := V_CDIMPOSTRIB||C_ICMSST.CDIMPOSTO||'_';
       END LOOP;
      IF (C_IMP.IDTRATIMPO = 'A') THEN
         IF NOT((((C_IMP.IDIMPORECUP = 'S')  AND (C_IMP.CDFISCALIT = '1')) OR
                ((C_IMP.IDIMPORECUP <> 'S') AND (C_IMP.CDCCTBLPASS IS NOT NULL))) AND
                (C_IMP.IDTIPCONTAB = 'D')) THEN
            UPDATE ITEMPRODUTO
            SET VRCONTITEM = VRCONTITEM + NVL(C_IMP.VRIMPOSTOIT,0)
            WHERE CDFILIAL  = P_FILIAL
            AND NRLANCTONF  = P_LANCTONF
            AND NRSEQITPROD = C_IMP.NRSEQITPROD;
         END IF;
      ELSIF (C_IMP.IDTRATIMPO = 'D') THEN
         IF NOT(((C_IMP.IDIMPORECUP = 'S') AND (C_IMP.CDFISCALIT = '1')) OR
                ((C_IMP.IDIMPORECUP <> 'S') AND (C_IMP.CDCCTBLATIV IS NOT NULL)) AND
                (C_IMP.IDTIPCONTAB = 'D')) THEN
            UPDATE ITEMPRODUTO
            SET VRCONTITEM = VRCONTITEM - NVL(C_IMP.VRIMPOSTOIT,0)
            WHERE CDFILIAL    = P_FILIAL
              AND NRLANCTONF  = P_LANCTONF
              AND NRSEQITPROD = C_IMP.NRSEQITPROD;
         END IF;
      ELSIF C_IMP.IDTRATIMPO = 'V' THEN
         IF (C_IMP.IDIMPORECUP = 'S') AND (V_IDORIGDESTNF = 'L') THEN
            IF (C_IMP.CDCCTBLPASS IS NOT NULL) AND (C_IMP.CDFISCALIT = '1') THEN
               V_IMPOCONTAB := - C_IMP.VRIMPOSTOIT;
            END IF;
         END IF;

         IF C_IMP.IDTIPCONTAB = 'D' THEN
            UPDATE ITEMPRODUTO
            SET VRCONTITEM = VRCONTITEM + NVL(V_IMPOCONTAB,0)
            WHERE CDFILIAL    = P_FILIAL
              AND NRLANCTONF  = P_LANCTONF
              AND NRSEQITPROD = C_IMP.NRSEQITPROD;

         END IF;
      END IF;
      IF C_IMP.VRPERREDBCIT > 0 THEN
         V_PERDBCALC    := 100 - C_IMP.VRPERREDBCIT;
         V_TAXABASECALC := (100 - C_IMP.VRPERREDBCIT)/100;

         SELECT NVL(MAX(VRTOTAITEM) - MAX(VRDESCITEM), 0)
           INTO V_LIQUIITEM
           FROM ITEMPRODUTO
          WHERE CDFILIAL = P_FILIAL
            AND NRLANCTONF = P_LANCTONF
            AND NRSEQITPROD = C_IMP.NRSEQITPROD;

         V_CONTABCALC := (V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC));

         INSERT INTO ITEMPROIMPOS(
            CDFILIAL, NRLANCTONF, NRSEQITPROD, CDIMPOSTO, NRITPROIMPOS, CDFISCALIT,
            CDSITUTRIBIT, CDFISCOPERIT,  VRALIQITEM, VRPERREDBCIT, VRPARDEDIT,
            VRCONTITIMP, VRBASECALCIT, VRIMPOSTOIT, IDERROSIMPIT, IDAVISIMPIT, CDSITUTRIBITNFE,
            IDMODBCITNFE, IDMODBCSTITNFE, CDTPCREDPICOITE, CDNATUBCALPCIT)
         VALUES(
            P_FILIAL, P_LANCTONF, C_IMP.NRSEQITPROD, C_IMP.CDIMPOSTO, '2', '2',
            C_IMP.CDSITUTRIBIT, C_IMP.CDFISCOPERIT,  0, V_PERDBCALC, C_IMP.VRPARDEDIT,
            V_CONTABCALC, 0, 0, '00000', '00000', C_IMP.CDSITUTRIBITNFE,
            C_IMP.IDMODBCNFE, C_IMP.IDMODBCSTNFE, C_IMP.CDTPCRPICOSTNFE, C_IMP.CDNATUBCPCSTNFE);
      END IF;
      IF C_IMP.VRPERMAJBCIT > 0 THEN
         UPDATE ITEMPROIMPOS
         SET VRPERREDBCIT = VRPERMAJBCIT
         WHERE CDFILIAL = P_FILIAL
           AND NRLANCTONF = P_LANCTONF
           AND CDIMPOSTO = C_IMP.CDIMPOSTO
           AND NRSEQITPROD = C_IMP.NRSEQITPROD;
      END IF;
   END LOOP;

   FOR C_IT  IN (SELECT II.CDIMPOSTO, I.VRBRUTITEM, I.NRSEQITPROD, I.VRCONTITEM
                  FROM ITEMPRODUTO I, ITEMPROIMPOS II
                  WHERE I.CDFILIAL    = P_FILIAL
                    AND I.NRLANCTONF  = P_LANCTONF
                    AND I.CDFILIAL    = II.CDFILIAL
                    AND I.NRLANCTONF  = II.NRLANCTONF
                    AND I.NRSEQITPROD = II.NRSEQITPROD ) LOOP
      V_ICMS := 'N';
      FOR C_ICMS IN (SELECT CDIMPOSTO
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = C_IT.CDIMPOSTO
                     UNION ALL
                     SELECT CDIMPOSTO
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = C_IT.CDIMPOSTO)
      LOOP
         V_ICMS := 'S';
      END LOOP;

      IF (V_ICMS = 'S') THEN
         UPDATE ITEMPROIMPOS
         SET VRCONTITIMP = ROUND(VRCONTITIMP,2)
         WHERE (NRLANCTONF   = P_LANCTONF)         AND
               (CDFILIAL     = P_FILIAL)           AND
               (NRSEQITPROD  = C_IT.NRSEQITPROD) AND
               (CDIMPOSTO    = C_IT.CDIMPOSTO)   AND
               (NRITPROIMPOS = '2');
      END IF;

      SELECT NVL(MAX(VRCONTITIMP),0)
        INTO   V_VRREDUCAO
        FROM ITEMPROIMPOS
       WHERE (NRLANCTONF   = P_LANCTONF)
         AND (CDFILIAL     = P_FILIAL)
         AND (NRSEQITPROD  = C_IT.NRSEQITPROD)
         AND (CDIMPOSTO    = C_IT.CDIMPOSTO)
         AND (NRITPROIMPOS = '2');

      IF V_VRREDUCAO IS NULL THEN
         V_VRREDUCAO := 0;
      END IF;

      V_ICMS := 'N';
      FOR C_ICMS IN (SELECT CDIMPOSTO
                       FROM IMPOSTONFE N, IMPOSTO I
                      WHERE N.CDIMPOSTONFE = I.CDIMPOSTONFE
                        AND N.CDIMPOSTONFE = '00'
                        AND I.CDIMPOSTO = C_IT.CDIMPOSTO
                     UNION ALL
                     SELECT CDIMPOSTO
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = C_IT.CDIMPOSTO)
      LOOP
         V_ICMS := 'S';
      END LOOP;

      UPDATE ITEMPROIMPOS
      SET VRCONTITIMP = ROUND((C_IT.VRBRUTITEM - V_VRREDUCAO),2)
      WHERE (NRLANCTONF   = P_LANCTONF)         AND
            (CDFILIAL     = P_FILIAL)           AND
            (NRSEQITPROD  = C_IT.NRSEQITPROD) AND
            (CDIMPOSTO    = C_IT.CDIMPOSTO)   AND
            (NRITPROIMPOS = '1')                AND
            (NOT EXISTS(SELECT CDIMPOSTO
                          FROM IMPOSTO
                         WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));

      UPDATE ITEMPROIMPOS
      SET VRCONTITIMP = ROUND(C_IT.VRBRUTITEM,2)
      WHERE (NRLANCTONF   = P_LANCTONF)         AND
            (CDFILIAL     = P_FILIAL)           AND
            (NRSEQITPROD  = C_IT.NRSEQITPROD) AND
            (CDIMPOSTO    = C_IT.CDIMPOSTO)   AND
            (NRITPROIMPOS = '1')                AND
            (EXISTS(SELECT CDIMPOSTO
                      FROM IMPOSTO
                     WHERE CDIMPOSTRIB = ITEMPROIMPOS.CDIMPOSTO));

   END LOOP;
   V_SEQUIMPOSTNF := '01';
   IF V_IDOPERDEVONF = 'S' THEN
      FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT, CDSITUTRIBIT,
                                 CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(VRCONTITIMP) AS VRCONTITIMP, SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                 MAX(NRITPROIMPOS) AS NRITPROIMPOS, SUM(VRBCICMSSTRETIDO) VRBCICMSSTRETIDO, SUM(VRICMSSTRETIDO) VRICMSSTRETIDO,
                                 NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                            FROM ITEMPROIMPOS IT, IMPOSTO I
                           WHERE (CDFILIAL     = P_FILIAL)    AND
                                 (NRLANCTONF   = P_LANCTONF)  AND
                                 (IT.CDIMPOSTO = I.CDIMPOSTO) AND
                                 (((CDFISCALIT  = '1')  AND (IDIMPORECUP = 'S')) OR
                                 ((IDIMPORECUP <> 'S') AND (VRALIQITEM <> 0)))
                          GROUP BY IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT,
                                   CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, IDDIFALIQCUSPRI
                          UNION
                          SELECT IT.CDIMPOSTO, 0 AS VRALIQITEM, 0 AS VRPERREDBCIT, 0 AS VRPARDEDIT, CDFISCALIT, CDSITUTRIBIT,
                                 CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(VRCONTITIMP) AS VRCONTITIMP, 0 AS VRBASECALCIT, 0 AS VRIMPOSTOIT,
                                 MAX(NRITPROIMPOS) AS NRITPROIMPOS, SUM(VRBCICMSSTRETIDO) VRBCICMSSTRETIDO, SUM(VRICMSSTRETIDO) VRICMSSTRETIDO,
                                 NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                            FROM ITEMPROIMPOS IT, IMPOSTO I
                           WHERE (CDFILIAL     = P_FILIAL)    AND
                                 (NRLANCTONF   = P_LANCTONF)  AND
                                 (IT.CDIMPOSTO = I.CDIMPOSTO) AND
                                 (NRITPROIMPOS <> '3')        AND
                                 (((CDFISCALIT  <> '1') AND (IDIMPORECUP = 'S')) OR
                                 ((IDIMPORECUP  <> 'S') AND (VRALIQITEM = 0)))
                          GROUP BY IT.CDIMPOSTO, CDFISCALIT, CDSITUTRIBIT,
                                CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, IDDIFALIQCUSPRI
                          UNION
                          SELECT IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT, CDSITUTRIBIT,
                                 CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(VRCONTITIMP) AS VRCONTITIMP, SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                 MAX(NRITPROIMPOS) AS NRITPROIMPOS, SUM(VRBCICMSSTRETIDO) VRBCICMSSTRETIDO, SUM(VRICMSSTRETIDO) VRICMSSTRETIDO,
                                 NVL(IDDIFALIQCUSPRI, 'N') AS IDDIFALIQCUSPRI
                            FROM ITEMPROIMPOS IT, IMPOSTO I
                           WHERE (CDFILIAL     = P_FILIAL)    AND
                                 (NRLANCTONF   = P_LANCTONF)  AND
                                 (IT.CDIMPOSTO = I.CDIMPOSTO) AND
                                 (NRITPROIMPOS = '3')
                          GROUP BY IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT,
                                   CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, IDDIFALIQCUSPRI) LOOP


             INSERT INTO IMPOSTONF(
                CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF,
                VRBASECALCNF, VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, VRICMSSTRETIDO,
                IDTRIMPOSTNF, IDDIFALIQCUSPRN)
             VALUES(
                P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, ROUND(C_IMPOSTONF.VRCONTITIMP,2), C_IMPOSTONF.VRPERREDBCIT,
                C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT,2), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, C_IMPOSTONF.VRICMSSTRETIDO,
                C_IMPOSTONF.IDTRIMPSTII, C_IMPOSTONF.IDDIFALIQCUSPRI);

          V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
      END LOOP;
   ELSE
      FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT, CDSITUTRIBIT,
                                 CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(ROUND(VRCONTITIMP,2)) AS VRCONTITIMP,SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT,
                                 NRITPROIMPOS, SUM(VRBCICMSSTRETIDO) VRBCICMSSTRETIDO, SUM(VRICMSSTRETIDO) VRICMSSTRETIDO
                            FROM ITEMPROIMPOS IT, IMPOSTO I
                           WHERE (CDFILIAL     = P_FILIAL)    AND
                                 (NRLANCTONF   = P_LANCTONF)  AND
                                 (IT.CDIMPOSTO = I.CDIMPOSTO) AND
                                 (((CDFISCALIT  = '1') AND (IDIMPORECUP = 'S')) OR
                                 ((IDIMPORECUP <> 'S') AND (VRALIQITEM <> 0 )))
                          GROUP BY IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT,
                                   CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, NRITPROIMPOS
                          UNION
                          SELECT IT.CDIMPOSTO, 0 AS VRALIQITEM, 0 AS VRPERREDBCIT, 0 AS VRPARDEDIT, CDFISCALIT, CDSITUTRIBIT,
                                 CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(ROUND(VRCONTITIMP,2)) AS VRCONTITIMP, 0 AS VRBASECALCIT, 0 AS VRIMPOSTOIT,
                                 NRITPROIMPOS, SUM(VRBCICMSSTRETIDO) VRBCICMSSTRETIDO, SUM(VRICMSSTRETIDO) VRICMSSTRETIDO
                            FROM ITEMPROIMPOS IT, IMPOSTO I
                           WHERE (CDFILIAL      = P_FILIAL)    AND
                                 (NRLANCTONF    = P_LANCTONF)  AND
                                 (IT.CDIMPOSTO  = I.CDIMPOSTO) AND
                                 (((IT.CDFISCALIT <> '1') AND (IDIMPORECUP = 'S')) OR
                                 ((I.IDIMPORECUP  <> 'S') AND (VRALIQITEM = 0) ))
                          GROUP BY IT.CDIMPOSTO, CDFISCALIT, CDSITUTRIBIT,
                                   CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, NRITPROIMPOS ) LOOP


             INSERT INTO IMPOSTONF(
                CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF,
                VRBASECALCNF, VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF,
                CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF, VRBCICMSSTRETIDO, VRICMSSTRETIDO,
                IDTRIMPOSTNF)
             VALUES(
                P_FILIAL, P_LANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, C_IMPOSTONF.VRCONTITIMP, C_IMPOSTONF.VRPERREDBCIT,
                C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM, C_IMPOSTONF.VRPARDEDIT, ROUND(C_IMPOSTONF.VRIMPOSTOIT, 2), C_IMPOSTONF.CDFISCALIT, C_IMPOSTONF.CDSITUTRIBIT,
                C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS, C_IMPOSTONF.VRBCICMSSTRETIDO, C_IMPOSTONF.VRICMSSTRETIDO,
                C_IMPOSTONF.IDTRIMPSTII);

          V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
      END LOOP;
   END IF;

   FOR C_CARGA IN (SELECT DISTINCT CDIMPOSTO
                     FROM IMPOSTONF
                     WHERE CDFILIAL = P_FILIAL
                       AND NRLANCTONF = P_LANCTONF) LOOP

      V_CARGA := VALOR_CARGA_TRIBUTARIA(C_CARGA.CDIMPOSTO, P_FILIAL, P_LANCTONF);
      IF V_CARGA > 0 THEN
         UPDATE IMPOSTONF
            SET VRIMPCARGATRIBI = V_CARGA
           WHERE CDFILIAL = P_FILIAL
             AND NRLANCTONF = P_LANCTONF
             AND CDIMPOSTO = C_CARGA.CDIMPOSTO
             AND NRIMPOSNF = (SELECT MAX(NRIMPOSNF)
                                      FROM IMPOSTONF
                                      WHERE CDFILIAL = P_FILIAL
                                        AND NRLANCTONF = P_LANCTONF
                                        AND CDIMPOSTO = C_CARGA.CDIMPOSTO);

      END IF;
   END LOOP;

END;
/
